Subject: Re: brcm80211 breakage..

From: "Arend van Spriel" <[email-masked]>
Date: Thu, 12 Jan 2012 20:46:31 +0100

On 01/12/2012 08:00 PM, Linus Torvalds wrote:
> On Wed, Jan 11, 2012 at 11:13 PM, Linus Torvalds
> <[email-masked]> wrote:
>>
>> All the BCMA changes make the revert somewhat non-trivial, could
>> somebody who knows the code better please try to do it for me? It
>> doesn't look complicated, and I can try to do it myself tomorrow if
>> nobody else steps up, but I'd *really* prefer the guilty parties
>> themselves to do it, ok?
> 
> Since I had the hardware to test, I could work on this and try to
> figure out exactly what went wrong in that commit.

I was trying to get my hands on a card with SPROM to dig in and I still
intend to get it because Apples are no pears.

> The problem seems to be simple: the SPROM contents *have* to be read
> as aligned 16-bit words. Anything else seems to return 0xff and just
> fails the transaction.

I was already wondering what aspect of the patch was causing the issue.
The transaction size requirement seems likely and I was not aware.

> I didn't check all the combinations, of course, so who knows what the
> exact details are, but it does look like the sprom has very limited
> pci decode and simply refuses to touch anything but the one case it
> can handle.
> 
> I'll send out a patch that seems to get things to a working state for
> me. At least I have wireless connectivity again, I don't know if there
> are some other problems remaining.
> 
>                       Linus
> 

Thanks for putting the effort into this in the middle of a merge window.

Gr. AvS